set(0,'defaultTextInterpreter','latex')
set(0,'defaultAxesTickLabelInterpreter','latex')
set(0,'defaultLegendInterpreter','latex')

clear;
clc;

addpath('C:\Program Files (x86)\FAST v8\bin');
addpath('C:\Program Files (x86)\FAST v8\Utilities\MATLAB_Toolbox\Utilities');

%% create linearized models of wind turbine
fst_filename = '5MW\Test18.fst';
[pathstr, name, ~] = fileparts(fst_filename);
cd(pathstr);
fst_filename = name;
[status, result] = system(sprintf('fast_x64d %s.fst', fst_filename));
cd ..
disp(result)

%% check linearization results
LinRes = ReadFASTLinear(sprintf('%s\\%s.1.lin', pathstr, fst_filename));
turbine = ss(LinRes.A, LinRes.B, LinRes.C, LinRes.D, ...
    'InputName',  LinRes.u_desc, ...
    'StateName',  LinRes.x_desc, ...
    'OutputName', LinRes.y_desc' ...
    );

disp('x'' = A*x + B*u');
disp(turbine.A * cell2mat(LinRes.x_op) + turbine.B * cell2mat(LinRes.u_op));
disp('x'' FAST');
disp(cell2mat(LinRes.xdot_op));
disp('y = C*x + D*u');
disp(turbine.C * cell2mat(LinRes.x_op) + turbine.D * cell2mat(LinRes.u_op));
disp('y FAST');
disp(cell2mat(LinRes.y_op));
